﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TextBox
{
    public class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            Price = "0";
            Quantity = "0";
        }
        private string quantity;

        public string Quantity
        {
            get
            {
                return this.quantity;
            }
            set
            {
                if (this.quantity != value)
                {
                    this.quantity = value;
                    OnPropertyChanged("Quantity");
                    OnPropertyChanged("Total");
                }
            }
        }

        private string price;

        public string Price
        {
            get
            {
                return this.price;
            }
            set
            {
                if (this.price != value)
                {
                    this.price = value;
                    OnPropertyChanged("Price");
                    OnPropertyChanged("Total");
                }
            }
        }

        public string Total
        {
            get
            {
                double quantity;
                double price;
                if (double.TryParse(this.Quantity, out quantity) && double.TryParse(Price, out price))
                {
                    return (quantity * price).ToString();
                }
                else
                {
                    return "invalid input";
                }

            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
